import React from 'react'
import {
  BrowserRouter as Router,
  Route,
  Link,
  Switch
} from 'react-router-dom';

import { createStore } from 'redux'
import { Provider } from 'react-redux'

import ReactDOM from 'react-dom';
import './index.css';
import { addTemperature, addOnOff, addPercent } from './actions/index'
import App from './App';
import registerServiceWorker from './registerServiceWorker';
import { Sensor, TemperatureSensor, PercentSensor, OnOffSensor} from "./model-objet/sensors.js";
import { store } from './index';
import { connect } from 'react-redux'
var array_sensors = new Array();
var mqtt = require('mqtt');
var client = mqtt.connect('mqtt://127.0.0.1:8080');
var broker = "mqtt://127.0.0.1:8080";

client.on('connect', function () {
  client.subscribe('#');
});

client.on('message', function (topic, message) {

  var array_m = JSON.parse(message);
  array_m.topic = topic.split("/")[1];
  let present = false;
  //console.log(array_m);

  switch(array_m.type){

    case 'TEMPERATURE':
      present = false;
      for(let i=0; i<array_sensors.length;i++){
        if(array_m.topic === array_sensors[i].name){
          //console.log("present temperature");
          present = true;

          array_sensors[i].addTemperature(array_m.value);

          store.dispatch(addTemperature(array_m.topic, array_sensors[i].lastTemperature()))
        }
      }
      if(present === false){
        let sensor = new TemperatureSensor({'id':12, 'name':array_m.topic, 'dataSensor':array_m.value})
        array_sensors.push(sensor);
        //console.log("non present temperature");

      }
    break;

    case 'ON_OFF':
      present = false;
      for(let i=0; i<array_sensors.length;i++){
        if(array_m.topic === array_sensors[i].name){
          //console.log("present on_off");
          present = true;

          array_sensors[i].setOnOff(array_m.value);
          store.dispatch(addOnOff(array_m.topic, array_sensors[i].dataSensor.value))
          //console.log(array_sensors[i].dataSensor.value);
          //set_Box(document.querySelectorAll("[data-name='"+array_sensors[i]._name+"']")[0], array_sensors[i]);
        }
      }
      if(present === false){
        let sensor = new OnOffSensor({'id':12, 'name':array_m.topic, 'dataSensor':array_m.value});
        array_sensors.push(sensor);
        //console.log("non present on_off");
        //addBox("orange", "light", sensor);
        //TemperatureTemplate('title':test);
      }
    break;

    case 'PERCENT':
      present = false;
      for(let i=0; i<array_sensors.length;i++){
        if(array_m.topic === array_sensors[i].name){
          //console.log("present percent");
          present = true;

          array_sensors[i].addPercent(array_m.value);

          store.dispatch(addPercent(array_m.topic, array_sensors[i].lastPercent()))

          //console.log();
          //console.log(array_sensors[i].name + ":")
          //console.log("Data: " + array_sensors[i].dataSensor.values);
          //console.log("Derniere valeur: " + array_sensors[i].lastPercent());
          //console.log("Moyenne: " + array_sensors[i].dataSensor.moyValues());
          //set_Box(document.querySelectorAll("[data-name='"+array_sensors[i]._name+"']")[0], array_sensors[i]);
        }
      }
      if(present === false){
        let sensor = new PercentSensor({'id':12, 'name':array_m.topic, 'dataSensor':array_m.value});
        array_sensors.push(sensor);
      }
    break;

    default:

  }

});

class TemperatureTemplate extends React.Component{
  constructor(props) {
    super(props);
    this.state = {
      sensor_values:this.props.sensor_values
    }
  }

  componentWillReceiveProps(nextProps){
      this.setState({
        title: nextProps.title,
        actualTemperature :nextProps.actual,
        historique:nextProps.historique,
        sensor_values:nextProps.sensor_values
      });
      console.log("change")
  }

  render(){
    return (
      <div id="temperatureTemplate">
        <h2>{this.state.sensor_values.title}</h2>
        <TemperatureValeurActuelle temperature={this.state.sensor_values.actual}/>
        <TemperatureHistorique historique={this.state.sensor_values.historique}/>
      </div>
    );
  }
}

class TemperatureValeurActuelle extends React.Component{
  constructor(props) {
    super(props);
    this.state = {
      actualTemperature : props.temperature
    }
  }

  render(){
    return (
      <div id="valAct">Valeur actuelle: {this.state.actualTemperature}°C</div>
    );
  }
}

class TemperatureHistorique extends React.Component{
  constructor(props) {
    super(props);
    this.state = {
      historique : this.props.historique
    }
  }

  render(){
    return (
      <div id="histo">
        <span id="histoName">Historique:</span>
        <table>
          <tbody>
            <tr><td>{this.state.historique[0]}°C</td></tr>
            <tr id="trColor"><td>{this.state.historique[1]}°C</td></tr>
            <tr><td>{this.state.historique[2]}°C</td></tr>
            <tr id="trColor"><td>{this.state.historique[3]}°C</td></tr>
            <tr><td>{this.state.historique[4]}°C</td></tr>
          </tbody>
        </table>
      </div>
    );
  }
}

class OnOffTemplate extends React.Component{
  constructor(props) {
    super(props);
    this.state = {
      title:this.props.sensor_values.title,
      actualValue:this.props.sensor_values.actual
    }
  }

  componentWillReceiveProps(nextProps){
      this.setState({
        title: nextProps.title,
        actualValue :nextProps.actual
      });
  }

  render(){
    return (
      <div id="onOffTemplate">
        <h2>{this.state.title}</h2>
        <div id="valAct">Valeur actuelle: {this.state.actualValue}</div>
      </div>
    );
  }
}


class PercentTemplate extends React.Component{
  constructor(props) {
    super(props);
    this.state = {
      sensor_values: this.props.sensor_values
    }
  }

  componentWillReceiveProps(nextProps){
      this.setState({
        title: nextProps.title,
        actualTemperature :nextProps.actualPercent,
        historique:nextProps.historique,
        sensor_values:nextProps.sensor_values
      });
  }

  render(){
    return (
      <div id="temperatureTemplate">
        <h2>{this.state.sensor_values.title}</h2>
        <PercentValeurActuelle percent={this.state.sensor_values.actual}/>
        <PercentHistorique historique={this.state.sensor_values.historique}/>
      </div>
    );
  }
}

class PercentValeurActuelle extends React.Component{
  constructor(props) {
    super(props);
    this.state = {
      actualPercent : this.props.percent
    }
  }

  render(){
    return (
      <div id="valAct">Valeur actuelle: {this.state.actualPercent}%</div>
    );
  }
}

class PercentHistorique extends React.Component{
  constructor(props) {
    super(props);
    this.state = {
      historique : props.historique
    }
  }

  render(){
    return (
      <div id="histo">
        <span id="histoName">Historique:</span>
        <table>
          <tbody>
            <tr><td>{this.state.historique[0]}%</td></tr>
            <tr id="trColor"><td>{this.state.historique[1]}%</td></tr>
            <tr><td>{this.state.historique[2]}%</td></tr>
            <tr id="trColor"><td>{this.state.historique[3]}%</td></tr>
            <tr><td>{this.state.historique[4]}%</td></tr>
          </tbody>
        </table>
      </div>
    );
  }
}

const Home = () => (
  <div>
    <h2>{broker}</h2>
  </div>
)


class BasicExample extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      sensor_values : this.props.sensor_values
    }
    console.log(this.state.sensor_values);
  }

  render(){
    return(
      <Router>
        <div id="basicExample">
          <ul id="nav">
            <li id="navItem"><Link to="/" activeClassName="active">Home</Link></li>
            <li id="navItem"><Link to="/TemperatureChambre" activeClassName="active">Temperature Chambre</Link></li>
            <li id="navItem"><Link to="/TemperatureSalleA111" activeClassName="active">Temperature Salle A111</Link></li>
            <li id="navItem"><Link to="/MonAttention" activeClassName="active">Mon Attention</Link></li>
            <li id="navItem"><Link to="/MesYeux" activeClassName="active">Mes Yeux</Link></li>
          </ul>

            <Route exact path="/" component={Home}/>
            <Route path="/TemperatureChambre" component={() => <TemperatureTemplate sensor_values={this.state.sensor_values.sensor_1} />}/>
            <Route path="/TemperatureSalleA111" component={() => <TemperatureTemplate sensor_values={this.state.sensor_values.sensor_2}/>}/>
            <Route path="/MonAttention" component={() => <PercentTemplate sensor_values={this.state.sensor_values.sensor_3}/>}/>
            <Route path="/MesYeux" component={() => <OnOffTemplate sensor_values={this.state.sensor_values.sensor_4}/>}/>

        </div>
      </Router>
    );
  }
}

class Main extends React.Component{
  constructor(props) {
    super(props);
    this.state = {
      sensor_1:{
        title : this.props.title_1,
        actual: this.props.actual_1,
        historique: this.props.historique_1
      },
      sensor_2:{
        title : this.props.title_2,
        actual: this.props.actual_2,
        historique: this.props.historique_2
      },
      sensor_3:{
        title : this.props.title_3,
        actual: this.props.actual_3,
        historique: this.props.historique_3
      },
      sensor_4:{
        title : this.props.title_4,
        actual: this.props.actual_4
      }
    }
    console.log(this.state);
  }

  render(){
    return(
      <div id='main'>
        <BasicExample sensor_values={this.state}/>
      </div>
    );
  }
}

export default Main
